searchNodes=[{"doc":"A collection of utility functions to use this library.","ref":"LcdDisplay.html","title":"LcdDisplay","type":"module"},{"doc":"Executes a supported command that is specified.","ref":"LcdDisplay.html#execute/2","title":"LcdDisplay.execute/2","type":"function"},{"doc":"Starts a supervised display controller process.","ref":"LcdDisplay.html#start_display/2","title":"LcdDisplay.start_display/2","type":"function"},{"doc":"Wraps a given display driver and controls the display using that driver.","ref":"LcdDisplay.DisplayController.html","title":"LcdDisplay.DisplayController","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"LcdDisplay.DisplayController.html#child_spec/1","title":"LcdDisplay.DisplayController.child_spec/1","type":"function"},{"doc":"Delegates the specified operation to the display driver, and updates the state as needed.ExamplesDisplayController.execute(pid, {:print, &quot;Hello&quot;})","ref":"LcdDisplay.DisplayController.html#execute/2","title":"LcdDisplay.DisplayController.execute/2","type":"function"},{"doc":"Starts a display driver process and registers the process with a composite key of driver module and display name.","ref":"LcdDisplay.DisplayController.html#start_link/1","title":"LcdDisplay.DisplayController.start_link/1","type":"function"},{"doc":"Discovers a process by the composite key of driver module atom and display name.","ref":"LcdDisplay.DisplayController.html#whereis/1","title":"LcdDisplay.DisplayController.whereis/1","type":"function"},{"doc":"","ref":"LcdDisplay.DisplayController.html#t:display_driver/0","title":"LcdDisplay.DisplayController.display_driver/0","type":"type"},{"doc":"Supervises display controller processes.","ref":"LcdDisplay.DisplaySupervisor.html","title":"LcdDisplay.DisplaySupervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"LcdDisplay.DisplaySupervisor.html#child_spec/1","title":"LcdDisplay.DisplaySupervisor.child_spec/1","type":"function"},{"doc":"Creates a LcdDisplay.DisplayController process.Examplespid = DisplaySupervisor.display_controller( LcdDisplay.HD44780.PCF8575, %{ display_name: &quot;display 1&quot;, # the identifier i2c_bus: &quot;i2c-1&quot;, # I2C bus name i2c_address: 0x27, # 7-bit address rows: 2, # the number of display rows cols: 16, # the number of display columns font_size: &quot;5x8&quot; # &quot;5x10&quot; or &quot;5x8&quot; } )","ref":"LcdDisplay.DisplaySupervisor.html#display_controller/2","title":"LcdDisplay.DisplaySupervisor.display_controller/2","type":"function"},{"doc":"","ref":"LcdDisplay.DisplaySupervisor.html#start_link/1","title":"LcdDisplay.DisplaySupervisor.start_link/1","type":"function"},{"doc":"Lets you control GPIOs. A thin wrapper of elixir-circuits/circuits_gpio.","ref":"LcdDisplay.GPIO.html","title":"LcdDisplay.GPIO","type":"module"},{"doc":"Callback implementation for LcdDisplay.GPIO.Behaviour.open/2.","ref":"LcdDisplay.GPIO.html#open/2","title":"LcdDisplay.GPIO.open/2","type":"function"},{"doc":"Callback implementation for LcdDisplay.GPIO.Behaviour.write/2.","ref":"LcdDisplay.GPIO.html#write/2","title":"LcdDisplay.GPIO.write/2","type":"function"},{"doc":"Defines a behaviour required for GPIO abstraction.","ref":"LcdDisplay.GPIO.Behaviour.html","title":"LcdDisplay.GPIO.Behaviour","type":"behaviour"},{"doc":"","ref":"LcdDisplay.GPIO.Behaviour.html#c:open/2","title":"LcdDisplay.GPIO.Behaviour.open/2","type":"callback"},{"doc":"","ref":"LcdDisplay.GPIO.Behaviour.html#c:write/2","title":"LcdDisplay.GPIO.Behaviour.write/2","type":"callback"},{"doc":"","ref":"LcdDisplay.GPIO.Behaviour.html#t:gpio_pin/0","title":"LcdDisplay.GPIO.Behaviour.gpio_pin/0","type":"type"},{"doc":"Defines a behaviour required for an LCD driver.","ref":"LcdDisplay.HD44780.Driver.html","title":"LcdDisplay.HD44780.Driver","type":"behaviour"},{"doc":"Injects the common logic for an LCD driver. For display flags, please refer to HD44780 data sheet.Examplesuse LcdDisplay.HD44780.Driver","ref":"LcdDisplay.HD44780.Driver.html#__using__/1","title":"LcdDisplay.HD44780.Driver.__using__/1","type":"macro"},{"doc":"Executes the specified command and returns a new display state.","ref":"LcdDisplay.HD44780.Driver.html#c:execute/2","title":"LcdDisplay.HD44780.Driver.execute/2","type":"callback"},{"doc":"Initializes the LCD driver and returns the initial display state.","ref":"LcdDisplay.HD44780.Driver.html#c:start/1","title":"LcdDisplay.HD44780.Driver.start/1","type":"callback"},{"doc":"Sends a data byte to the display.","ref":"LcdDisplay.HD44780.Driver.html#c:write_data/2","title":"LcdDisplay.HD44780.Driver.write_data/2","type":"callback"},{"doc":"Sends an instruction byte to the display.","ref":"LcdDisplay.HD44780.Driver.html#c:write_instruction/2","title":"LcdDisplay.HD44780.Driver.write_instruction/2","type":"callback"},{"doc":"Type that represents a supported display command. Some driver modules do not support the backlight LED commands.Supported CommandDescription:clearClear the display.:homeMove the cursor home.:printPrint a text at the current cursor.:set_cursorSet the cursor position (row and column).:cursorSwitch on/off the underline cursor.:displaySwitch on/off the display without losing what is on it.:blinkSwitch on/off the block cursor.:autoscrollMake existing text shift when new text is printed.:text_directionMake text flow left/right from the cursor.:scrollScroll text left and right.:leftMove the cursor left.:rightMove the cursor right.:charProgram custom character to CGRAM.:backlightSwitch on/off the backlight.:redSwitch on/off the red LED.:greenSwitch on/off the green LED.:blueSwitch on/off the blue LED.","ref":"LcdDisplay.HD44780.Driver.html#t:command/0","title":"LcdDisplay.HD44780.Driver.command/0","type":"type"},{"doc":"","ref":"LcdDisplay.HD44780.Driver.html#t:config/0","title":"LcdDisplay.HD44780.Driver.config/0","type":"type"},{"doc":"Type that represents an available display feature.","ref":"LcdDisplay.HD44780.Driver.html#t:feature/0","title":"LcdDisplay.HD44780.Driver.feature/0","type":"type"},{"doc":"","ref":"LcdDisplay.HD44780.Driver.html#t:num_cols/0","title":"LcdDisplay.HD44780.Driver.num_cols/0","type":"type"},{"doc":"","ref":"LcdDisplay.HD44780.Driver.html#t:num_rows/0","title":"LcdDisplay.HD44780.Driver.num_rows/0","type":"type"},{"doc":"Type that represents the display state.","ref":"LcdDisplay.HD44780.Driver.html#t:t/0","title":"LcdDisplay.HD44780.Driver.t/0","type":"type"},{"doc":"Knows how to commuticate with HD44780 type display using GPIO pins directly. Supports the 4-bit mode only. You can turn on/off the backlight.Usageconfig = %{ display_name: &quot;display 1&quot;, pin_rs: 2, pin_rw: 3, pin_en: 4, pin_d4: 23, pin_d5: 24, pin_d6: 25, pin_d7: 26, pin_led: 12, } # Start the LCD driver and get the initial display state. {:ok, display} = LcdDisplay.HD44780.GPIO.start(config) # Run a command and the display state will be updated. {:ok, display} = LcdDisplay.HD44780.GPIO.execute(display, {:print, &quot;Hello world&quot;})","ref":"LcdDisplay.HD44780.GPIO.html","title":"LcdDisplay.HD44780.GPIO","type":"module"},{"doc":"","ref":"LcdDisplay.HD44780.GPIO.html#char/3","title":"LcdDisplay.HD44780.GPIO.char/3","type":"function"},{"doc":"Executes the specified command and returns a new display state.","ref":"LcdDisplay.HD44780.GPIO.html#execute/2","title":"LcdDisplay.HD44780.GPIO.execute/2","type":"function"},{"doc":"Initializes the LCD driver and returns the initial display state.","ref":"LcdDisplay.HD44780.GPIO.html#start/1","title":"LcdDisplay.HD44780.GPIO.start/1","type":"function"},{"doc":"The configuration options.","ref":"LcdDisplay.HD44780.GPIO.html#t:config/0","title":"LcdDisplay.HD44780.GPIO.config/0","type":"type"},{"doc":"","ref":"LcdDisplay.HD44780.GPIO.html#t:display_driver/0","title":"LcdDisplay.HD44780.GPIO.display_driver/0","type":"type"},{"doc":"Knows how to commuticate with HD44780 type display through the 8-bit I/O expander MCP23008. You can turn on/off the backlight.Usageiex(2)&gt; Circuits.I2C.detect_devices Devices on I2C bus &quot;i2c-1&quot;: * 32 (0x20) 1 devices detected on 1 I2C busesconfig = %{ display_name: &quot;display 1&quot;, # the identifier i2c_bus: &quot;i2c-1&quot;, # I2C bus name i2c_address: 0x20, # 7-bit address rows: 2, # the number of display rows cols: 16, # the number of display columns font_size: &quot;5x8&quot; # &quot;5x10&quot; or &quot;5x8&quot; } # Start the LCD driver and get the initial display state. {:ok, display} = LcdDisplay.HD44780.MCP23008.start(config) # Run a command and the display state will be updated. {:ok, display} = LcdDisplay.HD44780.MCP23008.execute(display, {:print, &quot;Hello world&quot;})Pin assignmentThis module assumes the following pin assignment:MCP23008HD44780GP0-GP1RS (Register Select)GP2E (Enable)GP3DB4 (Data Bus 4)GP4DB5 (Data Bus 5)GP5DB6 (Data Bus 6)GP6DB7 (Data Bus 7)GP7LED","ref":"LcdDisplay.HD44780.MCP23008.html","title":"LcdDisplay.HD44780.MCP23008","type":"module"},{"doc":"Executes the specified command and returns a new display state.","ref":"LcdDisplay.HD44780.MCP23008.html#execute/2","title":"LcdDisplay.HD44780.MCP23008.execute/2","type":"function"},{"doc":"Initializes the LCD driver and returns the initial display state.","ref":"LcdDisplay.HD44780.MCP23008.html#start/1","title":"LcdDisplay.HD44780.MCP23008.start/1","type":"function"},{"doc":"The configuration options.","ref":"LcdDisplay.HD44780.MCP23008.html#t:config/0","title":"LcdDisplay.HD44780.MCP23008.config/0","type":"type"},{"doc":"","ref":"LcdDisplay.HD44780.MCP23008.html#t:display_driver/0","title":"LcdDisplay.HD44780.MCP23008.display_driver/0","type":"type"},{"doc":"Knows how to commuticate with HD44780 type display through the 16-bit I/O expander MCP23017. You can turn on/off the backlight and change the LED color by switching on/off red, green and blue.Usageiex(2)&gt; Circuits.I2C.detect_devices Devices on I2C bus &quot;i2c-1&quot;: * 32 (0x20) 1 devices detected on 1 I2C busesconfig = %{ display_name: &quot;display 1&quot;, # the identifier i2c_bus: &quot;i2c-1&quot;, # I2C bus name i2c_address: 0x20, # 7-bit address rows: 2, # the number of display rows cols: 16, # the number of display columns font_size: &quot;5x8&quot; # &quot;5x10&quot; or &quot;5x8&quot; } # Start the LCD driver and get the initial display state. {:ok, display} = LcdDisplay.HD44780.MCP23017.start(config) # Run a command and the display state will be updated. {:ok, display} = LcdDisplay.HD44780.MCP23017.execute(display, {:print, &quot;Hello world&quot;}) # Turn on/off `:red`, `:green` and `:blue` to change the backlight color. {:ok, display} = LcdDisplay.HD44780.MCP23017.execute(display, {:red, false}) # Pick a random backlight color. {:ok, display} = LcdDisplay.HD44780.MCP23017.execute(display, :random_color)Pin assignmentThis module assumes the following pin assignment:GPIOAMCP23017HD44780GPA0-GPA1-GPA2-GPA3-GPA4-GPA5-GPA6LED REDGPA7LED GREENGPIOBMCP23017HD44780GPB0LED BLUEGPB1DB7 (Data Bus 7)GPB2DB6 (Data Bus 6)GPB3DB5 (Data Bus 5)GPB4DB4 (Data Bus 4)GPB5E (Enable)GPB6-GPB7RS (Register Select)","ref":"LcdDisplay.HD44780.MCP23017.html","title":"LcdDisplay.HD44780.MCP23017","type":"module"},{"doc":"Executes the specified command and returns a new display state.","ref":"LcdDisplay.HD44780.MCP23017.html#execute/2","title":"LcdDisplay.HD44780.MCP23017.execute/2","type":"function"},{"doc":"","ref":"LcdDisplay.HD44780.MCP23017.html#set_random_color/1","title":"LcdDisplay.HD44780.MCP23017.set_random_color/1","type":"function"},{"doc":"Initializes the LCD driver and returns the initial display state.","ref":"LcdDisplay.HD44780.MCP23017.html#start/1","title":"LcdDisplay.HD44780.MCP23017.start/1","type":"function"},{"doc":"The configuration options.","ref":"LcdDisplay.HD44780.MCP23017.html#t:config/0","title":"LcdDisplay.HD44780.MCP23017.config/0","type":"type"},{"doc":"","ref":"LcdDisplay.HD44780.MCP23017.html#t:display_driver/0","title":"LcdDisplay.HD44780.MCP23017.display_driver/0","type":"type"},{"doc":"","ref":"LcdDisplay.HD44780.MCP23017.html#t:rgb_key/0","title":"LcdDisplay.HD44780.MCP23017.rgb_key/0","type":"type"},{"doc":"Knows how to commuticate with HD44780 type display through the 16-bit I/O expander PCF8575. You can turn on/off the backlight.Usageiex(2)&gt; Circuits.I2C.detect_devices Devices on I2C bus &quot;i2c-1&quot;: * 39 (0x27) 1 devices detected on 1 I2C busesconfig = %{ display_name: &quot;display 1&quot;, # the identifier i2c_bus: &quot;i2c-1&quot;, # I2C bus name i2c_address: 0x27, # 7-bit address rows: 2, # the number of display rows cols: 16, # the number of display columns font_size: &quot;5x8&quot; # &quot;5x10&quot; or &quot;5x8&quot; } # Start the LCD driver and get the initial display state. {:ok, display} = LcdDisplay.HD44780.PCF8575.start(config) # Run a command and the display state will be updated. {:ok, display} = LcdDisplay.HD44780.PCF8575.execute(display, {:print, &quot;Hello world&quot;})Pin assignmentThis module assumes the following pin assignment:PCF8575HD44780P0RS (Register Select)P1-P2E (Enable)P3LEDP4DB4 (Data Bus 4)P5DB5 (Data Bus 5)P6DB6 (Data Bus 6)P7DB7 (Data Bus 7)","ref":"LcdDisplay.HD44780.PCF8575.html","title":"LcdDisplay.HD44780.PCF8575","type":"module"},{"doc":"Executes the specified command and returns a new display state.","ref":"LcdDisplay.HD44780.PCF8575.html#execute/2","title":"LcdDisplay.HD44780.PCF8575.execute/2","type":"function"},{"doc":"Initializes the LCD driver and returns the initial display state.","ref":"LcdDisplay.HD44780.PCF8575.html#start/1","title":"LcdDisplay.HD44780.PCF8575.start/1","type":"function"},{"doc":"The configuration options.","ref":"LcdDisplay.HD44780.PCF8575.html#t:config/0","title":"LcdDisplay.HD44780.PCF8575.config/0","type":"type"},{"doc":"","ref":"LcdDisplay.HD44780.PCF8575.html#t:display_driver/0","title":"LcdDisplay.HD44780.PCF8575.display_driver/0","type":"type"},{"doc":"Knows how to commuticate with HD44780 type display through the 8-bit shift register SN74HC595. You can turn on/off the backlight.Usageiex&gt; Circuits.SPI.bus_names() [&quot;spidev0.0&quot;, &quot;spidev0.1&quot;]config = %{ display_name: &quot;display 1&quot;, # the identifier spi_bus: &quot;spidev0.0&quot;, # SPI bus name rows: 2, # the number of display rows cols: 16, # the number of display columns font_size: &quot;5x8&quot; # &quot;5x10&quot; or &quot;5x8&quot; } # Start the LCD driver and get the initial display state. {:ok, display} = LcdDisplay.HD44780.SN74HC595.start(config) # Run a command and the display state will be updated. {:ok, display} = LcdDisplay.HD44780.SN74HC595.execute(display, {:print, &quot;Hello world&quot;})Pin assignmentThis module assumes the following pin assignment:SN74HC595HD44780QA-QBRS (Register Select)QCE (Enable)QDDB7 (Data Bus 7)QEDB6 (Data Bus 6)QFDB5 (Data Bus 5)QGDB4 (Data Bus 4)QHLED","ref":"LcdDisplay.HD44780.SN74HC595.html","title":"LcdDisplay.HD44780.SN74HC595","type":"module"},{"doc":"Executes the specified command and returns a new display state.","ref":"LcdDisplay.HD44780.SN74HC595.html#execute/2","title":"LcdDisplay.HD44780.SN74HC595.execute/2","type":"function"},{"doc":"Initializes the LCD driver and returns the initial display state.","ref":"LcdDisplay.HD44780.SN74HC595.html#start/1","title":"LcdDisplay.HD44780.SN74HC595.start/1","type":"function"},{"doc":"The configuration options.","ref":"LcdDisplay.HD44780.SN74HC595.html#t:config/0","title":"LcdDisplay.HD44780.SN74HC595.config/0","type":"type"},{"doc":"","ref":"LcdDisplay.HD44780.SN74HC595.html#t:display_driver/0","title":"LcdDisplay.HD44780.SN74HC595.display_driver/0","type":"type"},{"doc":"A collection of utility functions that are used for display drivers.","ref":"LcdDisplay.HD44780.Util.html","title":"LcdDisplay.HD44780.Util","type":"module"},{"doc":"Adjusts the backlight-related values in the display driver state.Examples # Default to the white LED when no color is specified. iex&gt; LcdDisplay.HD44780.Util.adjust_backlight_config(%{backlight: true, red: false, green: false, blue: false}) %{backlight: true, blue: true, green: true, red: true} # Turn off all colors when the backlight is turned off. iex&gt; LcdDisplay.HD44780.Util.adjust_backlight_config(%{backlight: false, red: true, green: true, blue: true}) %{backlight: false, blue: false, green: false, red: false} # Else do nothing iex&gt; LcdDisplay.HD44780.Util.adjust_backlight_config(%{backlight: true, red: true, green: false, blue: false}) %{backlight: true, blue: false, green: false, red: true}","ref":"LcdDisplay.HD44780.Util.html#adjust_backlight_config/1","title":"LcdDisplay.HD44780.Util.adjust_backlight_config/1","type":"function"},{"doc":"Determine a list of row offsets based on how many columns the display has.0x00: | ROW 0 | ROW 2 | 0x40: | ROW 1 | ROW 3 |For more info, please refer to Hitachi HD44780 datasheet page 10.Examplesiex&gt; LcdDisplay.HD44780.Util.ddram_row_offsets(8) {0, 64, 8, 72} iex&gt; LcdDisplay.HD44780.Util.ddram_row_offsets(16) {0, 64, 16, 80} iex&gt; LcdDisplay.HD44780.Util.ddram_row_offsets(20) {0, 64, 20, 84}","ref":"LcdDisplay.HD44780.Util.html#ddram_row_offsets/1","title":"LcdDisplay.HD44780.Util.ddram_row_offsets/1","type":"function"},{"doc":"Determines a Display Data RAM (DDRAM) address based on the display configuration (rows and columns) and the zero-indexed cursor position (row and column).Examplesiex&gt; LcdDisplay.HD44780.Util.determine_ddram_address({0,0}, %{rows: 2, cols: 16}) 0 iex&gt; LcdDisplay.HD44780.Util.determine_ddram_address({0,15}, %{rows: 2, cols: 16}) 15 iex&gt; LcdDisplay.HD44780.Util.determine_ddram_address({1,0}, %{rows: 2, cols: 16}) 64 iex&gt; LcdDisplay.HD44780.Util.determine_ddram_address({1,15}, %{rows: 2, cols: 16}) 79","ref":"LcdDisplay.HD44780.Util.html#determine_ddram_address/2","title":"LcdDisplay.HD44780.Util.determine_ddram_address/2","type":"function"},{"doc":"Shuffles the RGB boolean values in the display driver state.","ref":"LcdDisplay.HD44780.Util.html#shuffle_color/1","title":"LcdDisplay.HD44780.Util.shuffle_color/1","type":"function"},{"doc":"Typically 2x16 or 4x20.","ref":"LcdDisplay.HD44780.Util.html#t:display_config/0","title":"LcdDisplay.HD44780.Util.display_config/0","type":"type"},{"doc":"","ref":"LcdDisplay.HD44780.Util.html#t:row_col_pos/0","title":"LcdDisplay.HD44780.Util.row_col_pos/0","type":"type"},{"doc":"Lets you communicate with hardware devices using the I2C protocol. A thin wrapper of elixir-circuits/circuits_i2c.","ref":"LcdDisplay.I2C.html","title":"LcdDisplay.I2C","type":"module"},{"doc":"Callback implementation for LcdDisplay.I2C.Behaviour.open/1.","ref":"LcdDisplay.I2C.html#open/1","title":"LcdDisplay.I2C.open/1","type":"function"},{"doc":"Callback implementation for LcdDisplay.I2C.Behaviour.write/3.","ref":"LcdDisplay.I2C.html#write/3","title":"LcdDisplay.I2C.write/3","type":"function"},{"doc":"Defines a behaviour required for I2C abstraction.","ref":"LcdDisplay.I2C.Behaviour.html","title":"LcdDisplay.I2C.Behaviour","type":"behaviour"},{"doc":"","ref":"LcdDisplay.I2C.Behaviour.html#c:open/1","title":"LcdDisplay.I2C.Behaviour.open/1","type":"callback"},{"doc":"","ref":"LcdDisplay.I2C.Behaviour.html#c:write/3","title":"LcdDisplay.I2C.Behaviour.write/3","type":"callback"},{"doc":"","ref":"LcdDisplay.I2C.Behaviour.html#t:data/0","title":"LcdDisplay.I2C.Behaviour.data/0","type":"type"},{"doc":"","ref":"LcdDisplay.I2C.Behaviour.html#t:i2c_address/0","title":"LcdDisplay.I2C.Behaviour.i2c_address/0","type":"type"},{"doc":"","ref":"LcdDisplay.I2C.Behaviour.html#t:i2c_bus/0","title":"LcdDisplay.I2C.Behaviour.i2c_bus/0","type":"type"},{"doc":"Manages processes.","ref":"LcdDisplay.ProcessRegistry.html","title":"LcdDisplay.ProcessRegistry","type":"module"},{"doc":"","ref":"LcdDisplay.ProcessRegistry.html#child_spec/1","title":"LcdDisplay.ProcessRegistry.child_spec/1","type":"function"},{"doc":"Starts a unique registry.","ref":"LcdDisplay.ProcessRegistry.html#start_link/0","title":"LcdDisplay.ProcessRegistry.start_link/0","type":"function"},{"doc":"Returns a standardized via-tuple for this registry.Examplesiex&gt; ProcessRegistry.via_tuple(SomeKey) {:via, Registry, {ProcessRegistry, SomeKey}}","ref":"LcdDisplay.ProcessRegistry.html#via_tuple/1","title":"LcdDisplay.ProcessRegistry.via_tuple/1","type":"function"},{"doc":"","ref":"LcdDisplay.ProcessRegistry.html#whereis_name/1","title":"LcdDisplay.ProcessRegistry.whereis_name/1","type":"function"},{"doc":"Lets you communicate with hardware devices using the SPI protocol. A thin wrapper of elixir-circuits/circuits_spi.","ref":"LcdDisplay.SPI.html","title":"LcdDisplay.SPI","type":"module"},{"doc":"Callback implementation for LcdDisplay.SPI.Behaviour.open/2.","ref":"LcdDisplay.SPI.html#open/2","title":"LcdDisplay.SPI.open/2","type":"function"},{"doc":"Callback implementation for LcdDisplay.SPI.Behaviour.transfer/2.","ref":"LcdDisplay.SPI.html#transfer/2","title":"LcdDisplay.SPI.transfer/2","type":"function"},{"doc":"Defines a behaviour required for SPI abstraction.","ref":"LcdDisplay.SPI.Behaviour.html","title":"LcdDisplay.SPI.Behaviour","type":"behaviour"},{"doc":"","ref":"LcdDisplay.SPI.Behaviour.html#c:open/2","title":"LcdDisplay.SPI.Behaviour.open/2","type":"callback"},{"doc":"","ref":"LcdDisplay.SPI.Behaviour.html#c:transfer/2","title":"LcdDisplay.SPI.Behaviour.transfer/2","type":"callback"},{"doc":"","ref":"LcdDisplay.SPI.Behaviour.html#t:data/0","title":"LcdDisplay.SPI.Behaviour.data/0","type":"type"},{"doc":"","ref":"LcdDisplay.SPI.Behaviour.html#t:spi_address/0","title":"LcdDisplay.SPI.Behaviour.spi_address/0","type":"type"},{"doc":"","ref":"LcdDisplay.SPI.Behaviour.html#t:spi_bus/0","title":"LcdDisplay.SPI.Behaviour.spi_bus/0","type":"type"},{"doc":"LcdDisplay LcdDisplay allows you to control a Hitachi HD44780-compatible Liquid-crystal display (LCD) in Elixir.","ref":"readme.html","title":"LcdDisplay","type":"extras"},{"doc":"You can install LcdDisplay by adding lcd_display to your list of dependencies in mix.exs:def deps do [ {:lcd_display, &quot;0.1.0&quot;} ] end","ref":"readme.html#installation","title":"LcdDisplay - Installation","type":"extras"},{"doc":"As an example, if you want to control a Hitachi HD44780 type display through the 16-bit I/O expander PCF8575, you can use LcdDisplay.HD44780.PCF8575 module as a display driver.Start an LCD driver and get a PIDdriver_module = LcdDisplay.HD44780.PCF8575 driver_config = %{ display_name: &quot;display 1&quot;, # the identifier i2c_bus: &quot;i2c-1&quot;, # I2C bus name i2c_address: 0x27, # 7-bit address rows: 2, # the number of display rows cols: 16, # the number of display columns font_size: &quot;5x8&quot; # &quot;5x10&quot; or &quot;5x8&quot; } pid = LcdDisplay.start_display(driver_module, driver_config)Run commandsPlease refer to the LcdDisplay.HD44780.Driver documentation for supported display commands.LcdDisplay.execute(pid, {:print, &quot;Hello world&quot;}) LcdDisplay.execute(pid, :clear)Driver modulesParallel I/OWhen you connect an LCD standalone directly to the GPIO pins on your target device, the LcdDisplay.HD44780.GPIO driver module is useful.As exapmles, here are some relevant Adafruit products:Standard LCD 16x2 - white on blueStandard LCD 20x4 - white on blueRGB backlight LCD 16x2 - black on RGBRGB backlight LCD 16x2 - RGB on blackSerial I/OWhen you connect an LCD through an I/O expander, one of the following driver modules can be used. Different products out there use different I/O expanders, so please be aware of which I/O expander you are using if you use something like an I2C backpack. Also the pin assignment between the LCD and the I/O expander is important.LcdDisplay.HD44780.PCF8575 - I2CLcdDisplay.HD44780.MCP23008 - I2CLcdDisplay.HD44780.MCP23017 - I2CLcdDisplay.HD44780.SN74HC595 - SPIIt is easy to make your own driver modules in case you want a custom pin assignment, a different I/O expander or some custom features.As exapmles, here are some relevant Adafruit products:i2c / SPI character LCD backpackLCD Shield Kit w/ 16x2 Character Display","ref":"readme.html#usage","title":"LcdDisplay - Usage","type":"extras"},{"doc":"ExLCD for inspiration","ref":"readme.html#thanks","title":"LcdDisplay - Thanks","type":"extras"},{"doc":"HD44780 data sheetPCF8575 data sheetMCP23008 data sheetMCP23017 data sheetSN74HC595 data sheet","ref":"readme.html#links","title":"LcdDisplay - Links","type":"extras"}]